
proc generate_ip_cores {mhsinst} {
    set pcoredir [xget_hw_pcore_dir $mhsinst]
    set ngcfolder $pcoredir../netlist
    puts $ngcfolder
    set verilogfolder $pcoredir../hdl/verilog
    puts $verilogfolder
    set cgpfile $ngcfolder/coregen.cgp
    #generate 32-bit FIFO
    set ipcore_ngc $ngcfolder/fifo_32x512.ngc
    set ipcore_v $ngcfolder/fifo_32x512.v
    set ipcore_xco $ngcfolder/fifo_32x512.xco
    set netlist_exists [file exists $ipcore_ngc]  
    set stub_exists [file exists $ipcore_v]
    if {$netlist_exists != 1} {
        puts "Baptista Logistic Encryption: Generating 32-bit FIFO netlist using Coregen\n"  
        set result [catch {exec coregen -p $cgpfile -b $ipcore_xco -intstyle xflow}]
    }    
    if {$stub_exists != 1} {
        puts "Baptista Logistic Encryption: Moving Verilog stub to the HDL folder\n"  
        set result [catch {exec cp $fifo_v $verilogfolder}]
    }
    #generate 8-bit FIFO
    set ipcore_ngc $ngcfolder/fifo_8x512.ngc
    set ipcore_v $ngcfolder/fifo_8x512.v
    set ipcore_xco $ngcfolder/fifo_8x512.xco
    set netlist_exists [file exists $ipcore_ngc]  
    set stub_exists [file exists $ipcore_v]
    if {$netlist_exists != 1} {
        puts "Baptista Logistic Encryption: Generating 8-bit FIFO netlist using Coregen\n"  
        set result [catch {exec coregen -p $cgpfile -b $ipcore_xco -intstyle xflow}]
    }    
    if {$stub_exists != 1} {
        puts "Baptista Logistic Encryption: Moving Verilog stub to the HDL folder\n"  
        set result [catch {exec cp $fifo_v $verilogfolder}]
    }
    #generate floating point multiplier
    set ipcore_ngc $ngcfolder/fp_mul.ngc
    set ipcore_v $ngcfolder/fp_mul.v
    set ipcore_xco $ngcfolder/fp_mul.xco
    set netlist_exists [file exists $ipcore_ngc]  
    set stub_exists [file exists $ipcore_v]
    if {$netlist_exists != 1} {
        puts "Baptista Logistic Encryption: Generating Floating Point Multiplier netlist using Coregen\n"  
        set result [catch {exec coregen -p $cgpfile -b $ipcore_xco -intstyle xflow}]
    }    
    if {$stub_exists != 1} {
        puts "Baptista Logistic Encryption: Moving Verilog stub to the HDL folder\n"  
        set result [catch {exec cp $fifo_v $verilogfolder}]
    }
    #generate floating point subtractor
    set ipcore_ngc $ngcfolder/fp_sub.ngc
    set ipcore_v $ngcfolder/fp_sub.v
    set ipcore_xco $ngcfolder/fp_sub.xco
    set netlist_exists [file exists $ipcore_ngc]  
    set stub_exists [file exists $ipcore_v]
    if {$netlist_exists != 1} {
        puts "Baptista Logistic Encryption: Generating Floating Point Subtractor netlist using Coregen\n"  
        set result [catch {exec coregen -p $cgpfile -b $ipcore_xco -intstyle xflow}]
    }    
    if {$stub_exists != 1} {
        puts "Baptista Logistic Encryption: Moving Verilog stub to the HDL folder\n"  
        set result [catch {exec cp $fifo_v $verilogfolder}]
    }
    #generate floating point comparator
    set ipcore_ngc $ngcfolder/fp_comp.ngc
    set ipcore_v $ngcfolder/fp_comp.v
    set ipcore_xco $ngcfolder/fp_comp.xco
    set netlist_exists [file exists $ipcore_ngc]  
    set stub_exists [file exists $ipcore_v]
    if {$netlist_exists != 1} {
        puts "Baptista Logistic Encryption: Generating Floating Point Comparator netlist using Coregen\n"  
        set result [catch {exec coregen -p $cgpfile -b $ipcore_xco -intstyle xflow}]
    }    
    if {$stub_exists != 1} {
        puts "Baptista Logistic Encryption: Moving Verilog stub to the HDL folder\n"  
        set result [catch {exec cp $fifo_v $verilogfolder}]
    }
} 
